<?php

// CREATE USER IN DATABASE


// CREATE TABLES
$sql = "CREATE OR REPLACE TABLE `user` (
    `user_id` BIGINT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
    `md5_id` VARCHAR(200) UNIQUE,
    `full_name` TINYTEXT,
    `user_email` VARCHAR(220) NOT NULL UNIQUE,
    `user_level` TINYINT(4) NOT NULL DEFAULT 1,
    `pwd` VARCHAR(220),
    `date` DATE NOT NULL DEFAULT(CURRENT_DATE),
    `ckey` VARCHAR(220),
    `ctime` VARCHAR(220)
) DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

INSERT INTO `user` (full_name, user_email, user_level, pwd)
VALUES ('Admin', 'admin@svagard.no', 5, '-');


CREATE OR REPLACE TABLE plan_space (
    `space_id` INT auto_increment PRIMARY KEY,
    `space_name` tinytext,
    `owner_id` BIGINT(20),
    CONSTRAINT plan_space_owner_FK FOREIGN KEY (`owner_id`) REFERENCES `user`(`user_id`)
);

CREATE OR REPLACE TABLE plan_space_member (
    `space_id` INT auto_increment NOT NULL,
    `member_id` BIGINT(20) NOT NULL,
    `timestamp` DATETIME default current_timestamp() NOT NULL,
    PRIMARY KEY (`space_id`, `member_id`),
    CONSTRAINT space_member_FK FOREIGN KEY (`member_id`) REFERENCES `user`(`user_id`),
    CONSTRAINT space_member_space_FK FOREIGN KEY (`space_id`) REFERENCES `plan_space`(`space_id`)
);

CREATE OR REPLACE TABLE plan_store (
	`plan_store_id` INT auto_increment,
	`space_id` INT NOT NULL,
	`name` varchar(100) NOT NULL,
	`created` DATETIME default current_timestamp() NOT NULL,
	`state` ENUM('planning', 'shopping', 'closed') default 'planning',
    PRIMARY KEY (plan_store_id),
    CONSTRAINT plan_store_user_FK FOREIGN KEY (`space_id`) REFERENCES `plan_space`(`space_id`)
) DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

CREATE OR REPLACE TABLE plan_store_item (
	`plan_item_id` INT auto_increment NOT NULL,
    `plan_store_id` INT NOT NULL,
    `pos` tinyint(3) unsigned,
	`name` varchar(200) NOT NULL,
    `price` decimal(8,2) NOT NULL,
    `amount` tinyint(3) unsigned DEFAULT 1,
	PRIMARY KEY (plan_item_id),
    CONSTRAINT plan_store_item_FK FOREIGN KEY (plan_store_id) REFERENCES `plan_store`(`plan_store_id`)
) DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;


";

